searchData={"items":[{"type":"task","title":"mix deps.audit","doc":"Scan for security vulnerabilities in Mix dependencies (use `--help` for options)","ref":"Mix.Tasks.Deps.Audit.html"},{"type":"module","title":"MixAudit","doc":"","ref":"MixAudit.html"},{"type":"function","title":"MixAudit.version/0","doc":"","ref":"MixAudit.html#version/0"},{"type":"module","title":"MixAudit.Advisory","doc":"","ref":"MixAudit.Advisory.html"},{"type":"module","title":"MixAudit.Audit","doc":"","ref":"MixAudit.Audit.html"},{"type":"function","title":"MixAudit.Audit.report/2","doc":"","ref":"MixAudit.Audit.html#report/2"},{"type":"module","title":"MixAudit.CLI","doc":"","ref":"MixAudit.CLI.html"},{"type":"function","title":"MixAudit.CLI.run/1","doc":"","ref":"MixAudit.CLI.html#run/1"},{"type":"module","title":"MixAudit.CLI.Audit","doc":"","ref":"MixAudit.CLI.Audit.html"},{"type":"function","title":"MixAudit.CLI.Audit.ignored_advisory_ids_from_file/1","doc":"","ref":"MixAudit.CLI.Audit.html#ignored_advisory_ids_from_file/1"},{"type":"function","title":"MixAudit.CLI.Audit.run/1","doc":"","ref":"MixAudit.CLI.Audit.html#run/1"},{"type":"module","title":"MixAudit.CLI.Help","doc":"","ref":"MixAudit.CLI.Help.html"},{"type":"function","title":"MixAudit.CLI.Help.run/1","doc":"","ref":"MixAudit.CLI.Help.html#run/1"},{"type":"module","title":"MixAudit.CLI.Version","doc":"","ref":"MixAudit.CLI.Version.html"},{"type":"function","title":"MixAudit.CLI.Version.run/1","doc":"","ref":"MixAudit.CLI.Version.html#run/1"},{"type":"module","title":"MixAudit.Dependency","doc":"","ref":"MixAudit.Dependency.html"},{"type":"module","title":"MixAudit.Formatting","doc":"","ref":"MixAudit.Formatting.html"},{"type":"function","title":"MixAudit.Formatting.format/2","doc":"","ref":"MixAudit.Formatting.html#format/2"},{"type":"module","title":"MixAudit.Formatting.Human","doc":"","ref":"MixAudit.Formatting.Human.html"},{"type":"function","title":"MixAudit.Formatting.Human.format/1","doc":"","ref":"MixAudit.Formatting.Human.html#format/1"},{"type":"module","title":"MixAudit.Formatting.JSON","doc":"","ref":"MixAudit.Formatting.JSON.html"},{"type":"function","title":"MixAudit.Formatting.JSON.format/1","doc":"","ref":"MixAudit.Formatting.JSON.html#format/1"},{"type":"module","title":"MixAudit.Project","doc":"","ref":"MixAudit.Project.html"},{"type":"function","title":"MixAudit.Project.dependencies/1","doc":"","ref":"MixAudit.Project.html#dependencies/1"},{"type":"module","title":"MixAudit.Repo","doc":"","ref":"MixAudit.Repo.html"},{"type":"function","title":"MixAudit.Repo.advisories/0","doc":"","ref":"MixAudit.Repo.html#advisories/0"},{"type":"module","title":"MixAudit.Report","doc":"","ref":"MixAudit.Report.html"},{"type":"module","title":"MixAudit.Vulnerability","doc":"","ref":"MixAudit.Vulnerability.html"},{"type":"extras","title":"README","doc":"MixAudit  provides a  mix deps.audit  task to scan Mix dependencies for security vulnerabilities.\n   \n  It draw its inspiration from tools like   npm audit   and   bundler-audit  .","ref":"readme.html"},{"type":"extras","title":"Installation - README","doc":"","ref":"readme.html#installation"},{"type":"extras","title":"Project dependency - README","doc":"Add `mix_audit` to the `deps` function in your project’s `mix.exs` file:\n\n```elixir\ndefp deps do\n  [\n    {:mix_audit, \"~> 2.1\", only: [:dev, :test], runtime: false}\n  ]\nend\n```\n\nThen run `mix do deps.get, deps.compile` inside your project’s directory.","ref":"readme.html#project-dependency"},{"type":"extras","title":"Local `escript` - README","doc":"If you do not wish to include `mix_audit` in your project dependencies, you can install it as global `escript`:\n\n```bash\n$ mix escript.install hex mix_audit\n…\n* creating …/.mix/escripts/mix_audit\n```\n\nThe only difference is that instead of using the `mix deps.audit` task, you will have to use the created executable.","ref":"readme.html#local-escript"},{"type":"extras","title":"Requirements - README","doc":"- [Git](https://git-scm.com)\n- [Elixir](https://elixir-lang.org/) ~1.8","ref":"readme.html#requirements"},{"type":"extras","title":"Usage - README","doc":"To generate a security report, you can use the `deps.audit` Mix task:\n\n```bash\n$ mix deps.audit\n```","ref":"readme.html#usage"},{"type":"extras","title":"Options - README","doc":"| Option                   | Type   | Default             | Description                                                  |\n| ------------------------ | ------ | ------------------- | ------------------------------------------------------------ |\n| `--path`                 | String | _Current directory_ | The root path of the project to audit                        |\n| `--format`               | String | `\"human\"`           | The format of the report to generate (`\"json\"` or `\"human\"`) |\n| `--ignore-advisory-ids`  | String | `\"\"`                | Comma-separated list of advisory IDs to ignore               |\n| `--ignore-package-names` | String | `\"\"`                | Comma-separated list of package names to ignore              |\n| `--ignore-file`          | String | `\"\"`                | Path of the ignore file                                      |","ref":"readme.html#options"},{"type":"extras","title":"Example - README","doc":"","ref":"readme.html#example"},{"type":"extras","title":"How does it work? - README","doc":"MixAudit builds two lists when it’s executed in a project:\n\n1. A list of security advisories fetched from the GitHub-sourced [`elixir-security-advisories`](https://github.com/mirego/elixir-security-advisories) repository\n2. A list of Mix dependencies from the various `mix.lock` files in the project\n\nThen, it loops through each project dependency and tries to find security advisories that apply to it (through its package name) and that match its version specification (through the advisory vulnerable version ranges).\n\nIf one is found, a **vulnerability** (the combination of a **security advisory** and a **project dependency**) is then added to the report.\n\nThe task will exit with a `0` status only if the report _passes_ (ie. it reports no vulnerabilities). Otherwise, it will exit with a `1` status.\n\n## `mix deps.audit` vs. `mix hex.audit`\n\nMix provides a [`mix hex.audit` task](https://hexdocs.pm/hex/Mix.Tasks.Hex.Audit.html). According to its documentation, `mix hex.audit` shows all dependencies that have been marked as retired.\n\nMixAudit provides a `mix deps.audit` task (similar to [`npm audit`](https://docs.npmjs.com/cli/audit) and [`bundler-audit`](https://github.com/rubysec/bundler-audit)) that scans dependencies for [reported security vulnerabilities](https://github.com/mirego/elixir-security-advisories).\n\nBoth tasks are useful but they just don’t share the same purpose.","ref":"readme.html#how-does-it-work"},{"type":"extras","title":"License - README","doc":"`MixAudit` is © 2020 [Mirego](https://www.mirego.com) and may be freely distributed under the [New BSD license](http://opensource.org/licenses/BSD-3-Clause). See the [`LICENSE.md`](https://github.com/mirego/mix_audit/blob/main/LICENSE.md) file.\n\nThe detective hat logo is based on [this lovely icon by Vectors Point](https://thenounproject.com/term/detective/1883300), from The Noun Project. Used under a [Creative Commons BY 3.0](http://creativecommons.org/licenses/by/3.0/) license.","ref":"readme.html#license"},{"type":"extras","title":"About Mirego - README","doc":"[Mirego](https://www.mirego.com) is a team of passionate people who believe that work is a place where you can innovate and have fun. We’re a team of [talented people](https://life.mirego.com) who imagine and build beautiful Web and mobile applications. We come together to share ideas and [change the world](http://www.mirego.org).\n\nWe also [love open-source software](https://open.mirego.com) and we try to give back to the community as much as we can.","ref":"readme.html#about-mirego"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}